#ifndef H_CHICK
#define H_CHICK

#include <graphx.h>
#include <stdbool.h>
#include <stdint.h>

#include "gfx/gfx.h"

#define NUM_CHICKS 4

enum {
    LEFT,
    RIGHT
};

struct chick {
    uint24_t x;
    bool dir;
    bool standing;
    bool current_leg;
    uint8_t anim_frame;
    const char *quote;
};

void init_chick(struct chick *chick);
void update_chick(struct chick *out, const struct chick *in);
void draw_chick(const struct chick *chick);

void init_chick_sprites(void);

#define LEFT_LEG_X_OFFSET 4
#define LEFT_LEG_Y_OFFSET 50
#define RIGHT_LEG_X_OFFSET 17
#define RIGHT_LEG_Y_OFFSET 49

#define LARGE_CHICKEN_SCALE 3
#define LARGE_CHICKEN_WIDTH (chicken_width * LARGE_CHICKEN_SCALE)
#define LARGE_CHICKEN_HEIGHT (60 * LARGE_CHICKEN_SCALE)

extern gfx_sprite_t *large_chicken;
extern gfx_sprite_t *chicken_square;

#endif
