#ifndef H_LOCATION
#define H_LOCATION

#include <stdbool.h>
#include <stdint.h>
#include <time.h>

#include "util.h"

struct location_data {
    float latitude;
    float longitude;
    int8_t time_zone; // Offset from UTC when DST is inactive
    bool use_dst;
    uint8_t dst_start_month;
    struct month_relative_day dst_start_day;
    uint8_t dst_end_month;
    struct month_relative_day dst_end_day;
};

// If no location data exists, saves and returns the default location data
const struct location_data *get_location_data(void);

bool is_on_dst(const struct location_data *loc, const struct tm *tm);

#endif
